//main.c

//TEAM NAHVG




#include "basic_io.h"
#include "DM9000A.h"
#include <alt_types.h>
#include "alt_up_ps2_port.h"
#include "ps2_mouse.h"
#include "VGA.h"
#include <string.h>
#include <math.h>
#define IOWR_VGA_DATA(base, offset, data) \
IOWR_16DIRECT(base, (offset) * 2, data)
#define MAX_MSG_LENGTH 128
#define delay 6000

// Ethernet MAC address.  Choose the last three bytes yourself
unsigned char mac_address[6] = { 0x01, 0x60, 0x6E, 0x11, 0x02, 0x0F  };

unsigned int receive_buffer_length;
unsigned char receive_buffer[1600];
unsigned long checksum;
int data_mouse;
int ctrl_mouse;
int collision_ethernet=0;
int bytes_mouse;
int data_reg1;
int ethernet_x = 520, ethernet_y = 200;
int xdiff = 4, ydiff = 4;
int puck_x = 320, puck_y = 232;
int score1 =0 ,score2 =0;
int vel_pad_x = 0, vel_pad_y = 0, prev_pos_x =0, prev_pos_y = 0;
int temp;

int user_x = 20 , user_y = 20;
int prev_puck_x =0, prev_puck_y=0;
int vel_pad_et_x = 0, vel_pad_et_y = 0, prev_et_pos_x =0, prev_et_pos_y = 0;
int vel_pad = 1, v = 0, collision = 0;
int vel_pad_et = 1;
int vel_puck = 1, vel_puck_x = 0, vel_puck_y = 0;
int d=1, dx=0,dy=0;
float ax=0.0,ay=0.0;
int counter= 10000;
int signx=1, signy=1;
int sx, sy;
float  ratio = 0.0;
extern int x_sign, y_sign;
#define UDP_PACKET_PAYLOAD_OFFSET 42
#define UDP_PACKET_LENGTH_OFFSET 38

#define UDP_PACKET_PAYLOAD (transmit_buffer + UDP_PACKET_PAYLOAD_OFFSET)



unsigned char transmit_buffer[] = {
          // Ethernet MAC header
          0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, // Destination MAC address
          0x01, 0x60, 0x6E, 0x11, 0x02, 0x0F, // Source MAC address
          0x08, 0x00,                         // Packet Type: 0x800 = IP
                                  
          // IP Header: bytes 14-33
          0x45,                // version (IPv4), header length = 20 bytes
          0x00,                // differentiated services field
          0x00,0x9C,           // total length: 20 bytes for IP header +
                               // 8 bytes for UDP header + 128 bytes for payload
          0x00, 0x35,          // packet ID
          0x00,                // flags
          0x00,                // fragment offset
          0x80,                // time-to-live
          0x11,                // protocol: 11 = UDP
          0x00,0x00,           // header checksum: incorrect
        
          0xc0,0xa8,0x01,0x01, // source IP address
          0xc0,0xa8,0x01,0xff, // destination IP address
                                  
          // UDP Header : 8 bytes
          0x67,0xd9, // source port port (26585: garbage)????
          0x27,0x2b, // destination port (10027: garbage)????
          0x00,0x88, // length (136: 8 for UDP header + 128 for data)
          0x00,0x00, // checksum: 0 = none
                                  
          // UDP payload 
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67,
          0x74, 0x65, 0x73, 0x74, 0x20, 0x6d, 0x73, 0x67
        };  



static void ethernet_interrupt_handler() 
{
	unsigned int receive_status;
	int i;
	receive_status = ReceivePacket(receive_buffer, &receive_buffer_length);
	if (receive_status == DMFE_SUCCESS) 
	{
      		if (receive_buffer_length >= 14) 
		{
         		
     			if (receive_buffer[12] == 8 && receive_buffer[13] == 0 && receive_buffer_length >= 34)
			{
       				// An IP packet
       				if (receive_buffer[23] == 0x11) 
				{
         				// A UDP packet
         				if (receive_buffer_length >= UDP_PACKET_PAYLOAD_OFFSET) 
					{
						  
					           ethernet_x = receive_buffer[UDP_PACKET_PAYLOAD_OFFSET]+500;
					           IOWR_VGA_DATA(VGA_BASE, 2, ethernet_x);
					           ethernet_y = ((receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+2] << 8) & 0xffff) + receive_buffer[UDP_PACKET_PAYLOAD_OFFSET+1];
					           IOWR_VGA_DATA(VGA_BASE, 3, ethernet_y);
				         }
         
       				} 
				else 
				{
         				printf("Received non-UDP packet\n");
				}
			}
			else 
			{
				printf("Received non-IP packet\n");
		        }
		}
		else 
		{
			printf("Malformed Ethernet packet\n");
		}
	}
	else 
	{
		printf("Error receiving packet\n");
	}

	/* Display the number of interrupts on the LEDs */ 

	//Clear the DM9000A ISR: PRS, PTS, ROS, ROOS 4 bits, by RW/C1 
	dm9000a_iow(ISR, 0x3F);
        
	/* Re-enable DM9000A interrupts */
	dm9000a_iow(IMR, INTR_set);
}


//static unsigned short packetId = 0;
int main()
{
 

 
                      

  int curMsgChar = 0;
           
 
  unsigned int packet_length;
  
  
    // Print a friendly welcome message
  printf("4840 Lab 2 started\n");
  
  
  // Initalize the DM9000 and the Ethernet interrupt handler
  DM9000_init(mac_address);
 
  
  alt_irq_register(DM9000A_IRQ, NULL, (void*)ethernet_interrupt_handler);
 
  // Initialize the keyboard
  printf("Please wait three seconds to initialize mouse\n");
  clear_FIFO();
  

  switch (get_mode()) {
  case PS2_KEYBOARD:
    printf("Error: Keyboard detected on PS/2 port\n");
    goto ErrorExit;
    break;
  case PS2_MOUSE:
        printf("Mouse Detected!\n");
        init();
	IOWR_VGA_DATA(VGA_BASE, 2, ethernet_x);
	IOWR_VGA_DATA(VGA_BASE, 3, ethernet_y);
        IOWR_VGA_DATA(VGA_BASE, 8, score2);
        IOWR_VGA_DATA(VGA_BASE, 7, score1);
     break;
  default:
    printf("Error: Unrecognized or no device on PS/2 port\n");
    goto ErrorExit;
  }
  
  printf("Ready!!!");

  // Clear the payload
  for (curMsgChar=MAX_MSG_LENGTH-1; curMsgChar>0; curMsgChar--) 
  {
    UDP_PACKET_PAYLOAD[curMsgChar] = 0;
  }
 
 
for (;;) {
    
      
      
      capture_mouse(&user_x , &user_y);
  
       
      IOWR_VGA_DATA(VGA_BASE, 0, user_x);
      IOWR_VGA_DATA(VGA_BASE, 1, user_y); 
      
      IOWR_VGA_DATA(VGA_BASE, 4, puck_x);
      IOWR_VGA_DATA(VGA_BASE, 5, puck_y);
      
      puck_x=puck_x-xdiff;
      puck_y=puck_y-ydiff;
            
     if (((ethernet_x-puck_x)*(ethernet_x-puck_x) + ((ethernet_y-puck_y)*(ethernet_y-puck_y))) <= 400)
     	{
	 collision_ethernet=1;
     	}
  	
	temp =  ( ((puck_x-user_x)*(puck_x-user_x)) + ((puck_y-user_y)*(puck_y-user_y))  );
     
     if (temp <= 400)
     	{
	 collision = 1;
    	}
      
     if( (puck_y>=212 && puck_y<=252) && (puck_x <= 11 || puck_x >= 629))      //when ball goes in the goal
       {
       	puck_y = 232;     
       	xdiff=  ydiff = 4;
        if ( puck_x <= 11)
         {                                   //update player2 scores if puck goes in player1 goal
          score2++;
          IOWR_VGA_DATA(VGA_BASE, 8, score2);
         }
        else if (puck_x >= 629)
         {                                   //update player1 scores if puck goes in player2 goal
          score1++;
          IOWR_VGA_DATA(VGA_BASE, 7, score1);
         }
        puck_x = 320;
       } 
      
     
     if(puck_y>454)
      {
       ydiff=ydiff*(-1);
       xdiff=xdiff;
      }  
      else if (puck_x>629)
      {
       xdiff=xdiff*(-1);
       ydiff=ydiff;
      }
      else if(puck_y<11)
      {
       ydiff=ydiff*(-1);			// Bounce back code at screen edges
       xdiff=xdiff;
      }  
      else if(puck_x<11)
      {
       xdiff=xdiff*(-1);
       ydiff=ydiff;     
      }
         
  //collision handling

    if (collision == 1)
    	{  
     	 vel_pad_x = user_x - prev_pos_x;   
      	 vel_pad_y = user_y - prev_pos_y;  
       
      	 d = sqrt(((user_x - puck_x)*(user_x - puck_x)) + ((user_y - puck_y)*(user_y - puck_y)));  //calculates distance between the two centres
      	 dx = (user_x - puck_x);           
      	 dy = (user_y - puck_y);

     	 vel_pad =  sqrt(((vel_pad_x)*(vel_pad_x)) + ((vel_pad_y)*(vel_pad_y)));   //velocity of paddle


   	if (vel_pad == 0 || ( (vel_pad_x == 0) &&  (vel_pad_y == 0)))                    //paddle is stationary
   		{
     		xdiff = xdiff * (-1);
     		ydiff = ydiff * (-1);
   
  		 }

   // direction modulation of puck depending on the direction of paddle
   

  	if ( (vel_pad_x > 0 ) && (vel_pad_y > 0) )
   	 {
     		xdiff = ((dx * vel_pad)/(12 *d))*(-1);
    		ydiff = ((dy * vel_pad)/(12 *d))*(-1);
   	 }
  	else if ( (vel_pad_x < 0 ) && (vel_pad_y < 0) )
  	 {
    		xdiff = ((dx * vel_pad)/(12 *d));
   		ydiff = ((dy * vel_pad)/(12 *d));
   	}
  	else if ( (vel_pad_x > 0 ) && (vel_pad_y < 0) )
  	 {
   		xdiff = ((dx * vel_pad)/(12 *d));
    		ydiff = ((dy * vel_pad)/(12 *d))*(-1);
   	}
  	else if ( (vel_pad_x < 0 ) && (vel_pad_y > 0) )
 	 {
  		 xdiff = ((dx * vel_pad)/(12 *d))*(-1);
 		 ydiff = ((dy * vel_pad)/(12 *d));
 	 }
 	else
  		{
  		 xdiff = ((dx * vel_pad)/(12 *d))*(-1);
  		 ydiff = ((dy * vel_pad)/(12 *d))*(-1);
 	 }
 
 	
 	
	 if (xdiff == 0 && ydiff == 0)
  		{
  		 xdiff = -4;
  		 ydiff = -4;  
  		}

  	// set minimum speed limits
	
	 if (xdiff!= 0 && xdiff > 0 && xdiff < 4)  
  		 {
  		 xdiff = 4;
 		 }
	
 	if (ydiff!= 0 && ydiff > 0 && ydiff < 4)
 		 {
   		 ydiff = 4;
  		 }
	
 	if (ydiff!= 0 && ydiff < 0 && ydiff > -4)
  		{
  		 ydiff = -4;
  		}
       
 	if (xdiff!= 0 && xdiff < 0 && xdiff > -4)
  		{
   		 xdiff = -4;
  		} 
       
   	// set maximum speed limits
   
 	if (xdiff > 10)
  		{
   		 while (xdiff > 4)
   			{
    	 		int q;
    	 		for (q = 0; q < 1000; q++ );
     			 xdiff --;
	 		}       
 		 }

       if (ydiff > 10)
  	{
   	while (ydiff > 4)
   	{
      	 int q;
      	 for ( q = 0; q < 1000; q++ );
       	 ydiff --;
	 }   
   	}

       
  	if (xdiff < -10)					
   	{
   	 while (xdiff < -4)
    	{
      	 int q;
      	 for (q = 0; q < 1000; q++ );
      	 xdiff ++;
	 }   
    	}

    
  	if (ydiff < -10)
   	{
    	 while (ydiff < -4)
    	{
    	 int q;
      	 for (q = 0; q < 1000; q++ );
      	 ydiff ++;
	 }   
    	}

  	prev_pos_x = user_x;
  	prev_pos_y = user_y;

  	collision = 0;
 }
 
 	//collision handling for second paddle
 
    if (collision_ethernet == 1)
    {   
    
        vel_pad_et_x = ethernet_x - prev_et_pos_x;
        vel_pad_et_y = ethernet_y - prev_et_pos_y;
        
        d = sqrt(((ethernet_x - puck_x)*(ethernet_x - puck_x)) + ((ethernet_y - puck_y)*(ethernet_y - puck_y)));
        dx = (ethernet_x - puck_x);
        dy = (ethernet_y - puck_y);
        
        vel_pad_et =  sqrt(((vel_pad_et_x)*(vel_pad_et_x)) + ((vel_pad_et_y)*(vel_pad_et_y)));
        
        if (vel_pad_et == 0 && ((vel_pad_x == 0) &&  (vel_pad_y == 0)))
        {
          
	 xdiff = xdiff * (-1);
	 ydiff = ydiff * (-1);
	    
        }
        
   
        if ( (vel_pad_et_x > 0 ) && (vel_pad_et_y > 0) )
        {
            
            xdiff = ((dx * vel_pad_et)/(12 *d))*(-1);
            ydiff = ((dy * vel_pad_et)/(12 *d))*(-1);
         }
        else if ( (vel_pad_et_x < 0 ) && (vel_pad_et_y < 0) )
        {
            
            xdiff = ((dx * vel_pad_et)/(12 *d));
            ydiff = ((dy * vel_pad_et)/(12 *d));
        }
        else if ( (vel_pad_et_x > 0 ) && (vel_pad_et_y < 0) )
        {
            xdiff = ((dx * vel_pad_et)/(12 *d));
            ydiff = ((dy * vel_pad_et)/(12 *d))*(-1);
        }
        else if ( (vel_pad_et_x < 0 ) && (vel_pad_et_y > 0) )
        {
            xdiff = ((dx * vel_pad_et)/(12 *d))*(-1);
            ydiff = ((dy * vel_pad_et)/(12 *d));
        }
        else
        {
            xdiff = ((dx * vel_pad_et)/(12 *d))*(-1);
            ydiff = ((dy * vel_pad_et)/(12 *d))*(-1);
        }
  
  
  
        
    
	 if (xdiff == 0 && ydiff == 0)
  		{
  		 xdiff = -4;
  		 ydiff = -4;  
  		}

  	// set minimum speed limits
	
	 if (xdiff!= 0 && xdiff > 0 && xdiff < 4)  
  		 {
  		 xdiff = 4;
 		 }
	
 	if (ydiff!= 0 && ydiff > 0 && ydiff < 4)
 		 {
   		 ydiff = 4;
  		 }
	
 	if (ydiff!= 0 && ydiff < 0 && ydiff > -4)
  		{
  		 ydiff = -4;
  		}
       
 	if (xdiff!= 0 && xdiff < 0 && xdiff > -4)
  		{
   		 xdiff = -4;
  		} 
       
   	// set maximum speed limits
   
 	if (xdiff > 10)
  		{
   		 while (xdiff > 4)
   			{
    	 		int q;
    	 		for (q = 0; q < 1000; q++ );
     			 xdiff --;
	 		}       
 		 }

       if (ydiff > 10)
  	{
   	while (ydiff > 4)
   	{
      	 int q;
      	 for ( q = 0; q < 1000; q++ );
       	 ydiff --;
	 }   
   	}

       
  	if (xdiff < -10)					
   	{
   	 while (xdiff < -4)
    	{
      	 int q;
      	 for (q = 0; q < 1000; q++ );
      	 xdiff ++;
	 }   
    	}

    
  	if (ydiff < -10)
   	{
    	 while (ydiff < -4)
    	{
    	 int q;
      	 for (q = 0; q < 1000; q++ );
      	 ydiff ++;
	 }   
    	}
        
       
        prev_et_pos_x = ethernet_x;
        prev_et_pos_y = ethernet_y;

        collision_ethernet = 0;
     }
	

    //corner cases for puck hitting the screen
    
    if( puck_x >= 630 || puck_x <= 10 )
     {
	 puck_x = prev_puck_x;			
	
     }
	 
    if( puck_y >= 458|| puck_y <= 10 )
     {
	puck_y = prev_puck_y;
	
     }


    // game over condition	
    if(score1==8 || score2==8)
     {
        exit(0);		
     }

      UDP_PACKET_PAYLOAD[curMsgChar++]=user_x & 0xFF;
      UDP_PACKET_PAYLOAD[curMsgChar++]=user_y & 0xFF;
      UDP_PACKET_PAYLOAD[curMsgChar++]=(user_y>>8) & 0xFF;
      
      UDP_PACKET_PAYLOAD[curMsgChar++]= (puck_x & 0xFF);
      UDP_PACKET_PAYLOAD[curMsgChar++]=(puck_x>>8) & 0xFF;
      UDP_PACKET_PAYLOAD[curMsgChar++]=puck_y & 0xFF;
      UDP_PACKET_PAYLOAD[curMsgChar++]=(puck_y>>8) & 0xFF;
      
      UDP_PACKET_PAYLOAD[curMsgChar++]=score1 & 0xFF;
      UDP_PACKET_PAYLOAD[curMsgChar++]=score2 & 0xFF;
      UDP_PACKET_PAYLOAD[curMsgChar] = 0; // Terminate the string
     
      packet_length = 8 + curMsgChar;
      transmit_buffer[UDP_PACKET_LENGTH_OFFSET] = packet_length >> 8;
      transmit_buffer[UDP_PACKET_LENGTH_OFFSET + 1] = packet_length & 0xff;	
	TransmitPacket(transmit_buffer, UDP_PACKET_PAYLOAD_OFFSET + curMsgChar + 1);

     // reset data
     for (curMsgChar=12; curMsgChar>0; curMsgChar--) 
     {
       UDP_PACKET_PAYLOAD[curMsgChar] = 0;
     }
     
     prev_puck_x = puck_x;
     prev_puck_y = puck_y;
     
}//end for 
  return 0;       
  ErrorExit:
  printf("Program terminated with error condition\n");
  exit(0);   
}
